using AutoMapper;
using MySqlX.XDevAPI.Common;
using OASystem.Domain;
using OASystem.Domain.Dtos.Groups;
using OASystem.Domain.Dtos.Resource;
using OASystem.Domain.Entities.Resource;
using OASystem.Domain.ViewModels.Resource;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Result = OASystem.Domain.Result;

namespace OASystem.Infrastructure.Repositories.Resource
{
    public class HotelDataRepository:BaseRepository<Res_HotelData,HotelDataView>
    {
        private readonly IMapper _mapper;
        public HotelDataRepository(SqlSugarClient sqlSugar, IMapper mapper) : base(sqlSugar)
        {
            _mapper= mapper;
        }

        public async Task<Result> _Info(int portType, int id)
        {
            if (id< 1) return new Result() { Code = -1, Msg = "请传入Status参数，1添加 2修改！" };


            string sql = string.Format(@"SELECT
  Id,
  City,
  [Name],
  [Level],
  [Address],
  Tel,
  Fax,
  Contact,
  ContactPhone,
  OtherInformation,
  Remark
FROM
  Res_HotelData
WHERE
  IsDel = 0
  AND Id = {0}", id);

            if (portType == 1 || portType == 2 || portType == 3)
            {
                var info = await _sqlSugar.SqlQueryable<HotelDataInfoView>(sql).FirstAsync();
                if (info != null) return new Result() { Code = 0, Msg = "操作成功!",Data = info };
                return new Result() { Code = -1, Msg = "暂无数据!" };
            }
           

            


            return new Result() { Code = -1, Msg = "请传入Status参数，1添加 2修改！" };
        }

        public async Task<Result> OperationHotelData(OperationHotelDto dto)
        {
            Result result = new Result() { Code = -2, Msg = "未知错误" };

            if (dto.Status == 1)//添加
            {
                string selectSql = string.Format(@"select * from Res_HotelData where Name='{0}' and IsDel='{1}'"
                                                   , dto.Name, 0);
                var HotelData = await _sqlSugar.SqlQueryable<Res_HotelData>(selectSql).FirstAsync();//查询是否存在
                if (HotelData != null)
                {
                    return result = new Result() { Code = -1, Msg = "该信息已存在，请勿重复添加！" };

                }
                else//不存在，可添加
                {
                    Res_HotelData _HotelDataDto = _mapper.Map<Res_HotelData>(dto);
                    int id = await AddAsyncReturnId(_HotelDataDto);
                    if (id == 0)
                    {
                        return result = new Result() { Code = -1, Msg = "添加失败！" };

                    }
                    return result = new Result() { Code = 0, Msg = "添加成功！", Data = new { Id = id } };
                }
            }
            else if (dto.Status == 2)//修改
            {
                bool res = await UpdateAsync(a => a.Id == dto.Id, a => new Res_HotelData
                {
                    City = dto.City,
                    Name = dto.Name,
                    Level = dto.Level,
                    Address = dto.Address,
                    Tel = dto.Tel,
                    Fax = dto.Fax,
                    Contact = dto.Contact,
                    ContactPhone = dto.ContactPhone,
                    OtherInformation = dto.OtherInformation,
                    Remark = dto.Remark,
                });
                if (!res)
                {
                    return result = new Result() { Code = -1, Msg = "修改失败！" };
                }
                return result = new Result() { Code = 0, Msg = "修改成功！" };
            }
            else
            {
                return result = new Result() { Code = -1, Msg = "请传入Status参数，1添加 2修改！" };
            }
        }



    }
}
